pr def predict_xb_sd
    args name b_matrix y_var var_list
	
// Use linear regression to estimate prediction of the b_marix of predictors and
// the standard errors of the forecast
qui describe `var_list', fullnames varlist
local var_list0=r(varlist)

reg `y_var' `var_list0', vce(robust)
matrix `b_matrix' = e(b)
predict `name', xb
replace `name'=0 if `name'<=0
g sd_`name'_temp = log( (`y_var'-`name')^2 )
reg sd_`name'_temp `var_list0' if `y_var'<., vce(robust)
predict sd_`name', xb
replace sd_`name' = exp(sd_`name')
replace sd_`name' = 0 if sd_`name'<=0
replace sd_`name' = sqrt(sd_`name')
drop sd_`name'_temp

end
