pr def predict_xb_sd2_facs
     args name b_matrix cond_var y_var var_list
	
// Use linear regression to estimate prediction of the b_marix of predictors and
// the standard errors of the forecast
*qui describe `var_list', fullnames varlist
local var_list0 = "`var_list'"
*local var_list0=r(varlist)

reg `y_var' `var_list0' if `cond_var'>0 & `cond_var'!=. [fw=${factor_op}], vce(robust)
matrix `b_matrix' = e(b)
predict `name', xb
replace `name'=0 if `name'<=0
g sd_`name'_temp = log( (`y_var'-`name')^2 )
reg sd_`name'_temp `var_list0' if `y_var'<. [fw=${factor_op}], vce(robust)
predict sd_`name', xb
replace sd_`name' = exp(sd_`name')
replace sd_`name' = 0 if sd_`name'<=0
replace sd_`name' = sqrt(sd_`name')

if ${pre_imp_op}==1 {
bysort ${pre_imp_vars}: egen xb_imp = median(`name')
replace `name' = xb_imp if `name'==.

bysort ${pre_imp_vars}: egen sd_imp = median(sd_`name')
replace sd_`name' = sd_imp if sd_`name'==. | sd_`name'<=0
sum sd_`name' if sd_`name'>0
replace sd_`name' = r(min) if sd_`name'==. | sd_`name'<=0
drop sd_imp xb_imp
}
//

drop sd_`name'_temp

end
