pr def predict_xb_sd3
    args name b_matrix y_var var_list
	
// Use linear regression to estimate prediction of the b_marix of predictors and
// the standard errors of the forecast
qui describe `var_list', fullnames varlist
local var_list0=r(varlist)

reg `y_var' i.(`var_list0'), vce(robust)
matrix `b_matrix' = e(b)
predict `name', xb
g sd_`name'_temp = (`y_var'-`name')^2
reg sd_`name'_temp i.(`var_list0') if `y_var'<., vce(robust)
predict sd_`name', xb
drop sd_`name'_temp

bysort `var_list0': egen `name'_2 = mean(`y_var')
g sd_`name'_temp = (`y_var'-`name'_2)^2 if `y_var'<.
*replace sd_`name' = min(sd_`name',sd_`name'_temp) 
*drop sd_`name'_temp `name'_2 
rename sd_`name'_temp sd_`name'_temp0
drop `name'_2 
bysort `var_list0': egen `name'_2 = median(`y_var')
g sd_`name'_temp = (`y_var'-`name'_2)^2 if `y_var'<.
replace sd_`name' = max(sd_`name', sd_`name'_temp, sd_`name'_temp0) if sd_`name'==0
egen sd_`name'_vs0 = rowmean(sd_`name' sd_`name'_temp sd_`name'_temp0)
replace sd_`name' = sd_`name'_vs0 if `y_var'>=0 & `y_var'<.
*replace sd_`name' = . if `y_var'>=0 & `y_var'<.
*replace sd_`name' = min(sd_`name',sd_`name'_temp) 
*drop sd_`name'_temp `name'_2
drop sd_`name'_temp sd_`name'_temp0 `name'_2 sd_`name'_vs0

replace sd_`name' = 0 if sd_`name'<=0
replace sd_`name' = sqrt(sd_`name')

end
