*clear
*global data_save "default_hist"
*global path_bs_do "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\Proyectos\2010_Household Risk"
*run "$path_bs_do\layoff_jobfind0" 

quietly {
use "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\2011\Data\Base_trabajo\EFH_11_allvars.dta", clear
joinby folio using "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\efh_imputada\base_imp_11_i15.dta", unmatched(master) update  //efh_imputada_median2
tab _merge
drop _merge
/* use "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\2011\Data\Base_trabajo\EFH_11_allvars.dta", clear
sum cf_dna cf_dt if a1==1
use "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\2011\Data\Base_trabajo\EFH_11_allvars.dta", clear
joinby folio using "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\efh_imputada\base_imp_11_i15.dta", unmatched(master) update  //efh_imputada_median2
sum cf_dna cf_dt if a1==1
use "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\efh_imputada\base_imp_11_i15.dta", clear //efh_imputada_median2
joinby folio using "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\2011\Data\Base_trabajo\EFH_11_allvars.dta", unmatched(master) update  //efh_imputada_median2
sum cf_dna cf_dt if a1==1  */

g tarjetas_bancaria_al_dia = . // 1-Todas tarjetas al dia "Pag el monto facturado", 2-Peor estado de pago es "Pag entre el facturado y el mnimo"
// 3-Peor estado de pago es "Pag el pago mnimo", 4-Peor estado de pago es "No pag o pag menos del mnimo", 5-Todas tarjetas reportan "No sabe, no responde"
forv k2=1/3 {  //Tarjetas bancarias
g F8_t1d`k2'=f30_t1d`k2'
replace F8_t1d`k2'=8 if F8_t1d`k2'<0
recode F8_t1d`k2' 8/9=8
replace tarjetas_bancaria_al_dia = 5 if tarjetas_bancaria_al_dia==. & F8_t1d`k2'==8
replace tarjetas_bancaria_al_dia = 1 if tarjetas_bancaria_al_dia==. & F8_t1d`k2'<8
replace tarjetas_bancaria_al_dia = 1 if tarjetas_bancaria_al_dia==5 & F8_t1d`k2'>=1 & F8_t1d`k2'<8
replace tarjetas_bancaria_al_dia = 2 if tarjetas_bancaria_al_dia<2. & F8_t1d`k2'==2
replace tarjetas_bancaria_al_dia = 3 if tarjetas_bancaria_al_dia<3. & F8_t1d`k2'==3
replace tarjetas_bancaria_al_dia = 4 if tarjetas_bancaria_al_dia<4. & F8_t1d`k2'==4
}
g tarjetas_cc_al_dia = .
forv k2=1/4 {  //Tarjetas de Casas C
g F8_t3d`k2'=f35_t3d`k2'
replace F8_t3d`k2'=8 if F8_t3d`k2'<0
recode F8_t3d`k2' 8/9=8
replace tarjetas_cc_al_dia = 5 if tarjetas_cc_al_dia==. & F8_t3d`k2'==8
replace tarjetas_cc_al_dia = 1 if tarjetas_cc_al_dia==. & F8_t3d`k2'<8
replace tarjetas_cc_al_dia = 1 if tarjetas_cc_al_dia==5 & F8_t3d`k2'>=1 & F8_t3d`k2'<8
replace tarjetas_cc_al_dia = 2 if tarjetas_cc_al_dia<2. & F8_t3d`k2'==2
replace tarjetas_cc_al_dia = 4 if tarjetas_cc_al_dia<3. & F8_t3d`k2'==3
}
//  //
forv k1=4/7 {  // 1/8  //  // Contruccin inicio de la deuda
forv k2=1/3 {  //recode pmen_`h'_td`k' 0=.
foreach x of varlist f18_a_t`k1'd`k2' f18_m_t`k1'd`k2' f18_1_a_t`k1'd`k2' f18_1_m_t`k1'd`k2' f19_a_t`k1'd`k2' f19_m_t`k1'd`k2' {
replace `x' = . if `x'>=97
}	
g meses_apagar_t`k1'd`k2' = (12*max(0,f19_a_t`k1'd`k2') + max(0, f19_m_t`k1'd`k2') ) if f19_a_t`k1'd`k2'!=.  | f19_m_t`k1'd`k2'!=.
g meses_inicio_t`k1'd`k2' = (12*max(0,f18_a_t`k1'd`k2') + max(0, f18_m_t`k1'd`k2') ) if f18_a_t`k1'd`k2'!=.  | f18_m_t`k1'd`k2'!=.
replace meses_inicio_t`k1'd`k2' = max(0,meses_inicio_t`k1'd`k2'-meses_apagar_t`k1'd`k2') if f19_a_t`k1'd`k2'!=.  | f19_m_t`k1'd`k2'!=.
replace meses_inicio_t`k1'd`k2' = . if f19_a_t`k1'd`k2'==.  & f19_m_t`k1'd`k2'==. & meses_inicio_t`k1'd`k2'<.
replace meses_inicio_t`k1'd`k2' = max(meses_inicio_t`k1'd`k2', 12*max(0,f18_1_a_t`k1'd`k2') +max(0,f18_1_m_t`k1'd`k2') ) if f18_1_a_t`k1'd`k2'==. | f18_1_m_t`k1'd`k2'==. 
replace meses_inicio_t`k1'd`k2' = max(0, meses_inicio_t`k1'd`k2') if meses_inicio_t`k1'd`k2'<.
}   //egen plazo_td`k'=rmean(pmen_1_td`k' pmen_2_td`k' pmen_3_td`k')	
egen meses_inicio_t`k1' = rowmax(meses_inicio_t`k1'd1 meses_inicio_t`k1'd2 meses_inicio_t`k1'd3)
egen meses_apagar_t`k1' = rowmax(meses_apagar_t`k1'd1 meses_apagar_t`k1'd2 meses_apagar_t`k1'd3)
drop meses_inicio_t`k1'd1 meses_inicio_t`k1'd2 meses_inicio_t`k1'd3 meses_apagar_t`k1'd1 meses_apagar_t`k1'd2 meses_apagar_t`k1'd3
} 
//    //   //

* Contruccin plazo por deuda
forv k=1/8 {
	forv h=1/3 {
		recode pmen_`h'_td`k' 0=.
	}
	egen plazo_td`k'=rmean(pmen_1_td`k' pmen_2_td`k' pmen_3_td`k')
} 

egen p_cons=rmean(plazo_td1 plazo_td2 plazo_td3 plazo_td4 plazo_td5 plazo_td6 plazo_td7 plazo_td8)
capture drop p_tbco 
g p_tbco = plazo_td1
g p_ccom = plazo_td3
g p_cbco = plazo_td4
g p_fin = plazo_td4
//
capture rename g_total gtotal
capture drop desem desem_h
capture drop year
capture drop numh
*capture drop *_old
capture drop  f1_td1- f17_3_td16
capture drop i1_1- l4
global path "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\Proyectos\2010_Household Risk\household_risk\simul_empleo_ing"
global pathbd "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\Proyectos\2010_Household Risk\household_risk\simul_empleo_ing\bases"
global path2b "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\Proyectos\2010_Household Risk\household_risk\empleo\bases"
global path4b "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\Proyectos\2010_Household Risk\simulation_time"
global factor_op "factor_cvars1112"

* Variables default de deuda
g df_vp=(e14==3) if a1==1 & e12==1
g df_vp_1=(e14==3 | e14==2) if a1==1 & e12==1
g df_hog=0   if a1==1
g df_hog_1=0 if a1==1
forv k=1/3{
replace df_hog=1 if a1==1  & (e14==3 | e42_`k'==3)
replace df_hog_1=1 if a1==1  & (e14==3 | e14==2 | e42_`k'==3 | e42_`k'==2)
}
g df_dna=.
forv k=1/6 {
replace df_dna=1 if (g9_`k'==1) & df_vp_1!=1 & a1==1 & cf_dna>0
replace df_dna=0 if (g9_`k'==2) & df_vp_1!=1 & a1==1 & cf_dna>0 & df_dna==.
}
replace df_dna=((g9_1==1 | g9_2==1 | g9_3==1 | g9_4==1 | g9_5==1 | g9_6==1) & a1==1 & df_vp_1!=1) if df_dna==0 | df_dna==.

//  Additional definition of Default (only valid for EFH 2010, 2011, 2014)
rename df_vp df_vp_original
rename df_dna df_dna_original
g EDF36=e14
g EDF37=e15
g EDF38=e16
replace EDF38=2 if e17<3
replace EDF38=2 if e17>=97 & e17<.
g e14_3 = (e12==1)
forv k2=1/3 {
g EDF73_`k2' = e42_`k2'
g EDF74_`k2' = e43_`k2' 
g EDF75_`k2' = e44_`k2' 
replace EDF75_`k2' = 2 if e45_`k2'<3
replace EDF75_`k2' = 2 if e45_`k2'>=97 & e45_`k2'<.
g e52_3_`k2' = (e40_`k2'==1)
}
// Default de Deuda
capture drop df_vp df_dna
g df_vp = (EDF36==3) if e14_3==1 & a1==1  //e14_3 or e11
replace df_vp = (EDF37>=3 & EDF37<.) if e14_3==1 & a1==1 & EDF36==2
replace df_vp = (EDF38==1) if e14_3==1 & a1==1 & df_vp==0
forv k=1/3{
replace df_vp = 0 if df_vp==. & e52_3_`k'==1 
replace df_vp=1 if a1==1  & e52_3_`k'==1 & EDF73_`k'==3
replace df_vp=1 if a1==1  & e52_3_`k'==1 & EDF73_`k'==2 & EDF74_`k'>=3 & EDF74_`k'<.
replace df_vp=1 if a1==1  & EDF75_`k'==1 
}
tab df_vp

forv k2=1/3 {  //   //   //   Adapt variable names for Consumo
g DF26_t4d`k2' = f35_t5d`k2'
g DF26_t5d`k2' = f35_t4d`k2'
g DF26_t6d`k2' = f35_t7d`k2'
g DF26_t7d`k2' = f35_t6d`k2'

g DF27_t4d`k2' = f36_t5d`k2' if f36_t5d`k2'<97
g DF27_t5d`k2' = f36_t4d`k2' if f36_t4d`k2'<97
g DF27_t6d`k2' = f36_t7d`k2' if f36_t7d`k2'<97
g DF27_t7d`k2' = f36_t6d`k2' if f36_t6d`k2'<97

g DF28_t4d`k2' = f37_t5d`k2'
g DF28_t5d`k2' = f37_t4d`k2'
g DF28_t6d`k2' = f37_t7d`k2'
g DF28_t7d`k2' = f37_t6d`k2'
replace DF28_t4d`k2' = 1 if f38_t5d`k2'==1
replace DF28_t5d`k2' = 1 if f38_t4d`k2'==1
replace DF28_t6d`k2' = 1 if f38_t7d`k2'==1
replace DF28_t7d`k2' = 1 if f38_t6d`k2'==1
g DF29_t4d`k2' = f39_t5d`k2' if f39_t5d`k2'<97
g DF29_t5d`k2' = f39_t4d`k2' if f39_t4d`k2'<97
g DF29_t6d`k2' = f39_t7d`k2' if f39_t7d`k2'<97
g DF29_t7d`k2' = f39_t6d`k2' if f39_t6d`k2'<97
g F40_t8d`k2' = f27_t8d`k2' if f28_t8d`k2'>=1 & f28_t8d`k2'<97 
replace F40_t8d`k2' = f23_t8d`k2' if F40_t8d`k2'==.  //Only for EFH 2011
}
g df_dna=.
quietly {
forv k2=1/3 {
forv k=4/7 {
replace df_dna=0 if DF26_t`k'd`k2'!=. & df_vp!=1 & a1==1 & cf_dna>0 & cf_dna<. & df_dna==.
replace df_dna=1 if DF26_t`k'd`k2'==3 & df_vp!=1 & a1==1 & cf_dna>0 & cf_dna<. & df_dna<.
replace df_dna=1 if DF26_t`k'd`k2'==2 & DF27_t`k'd`k2'>=3 & DF27_t`k'd`k2'<97 & df_vp!=1 & a1==1 & cf_dna>0 & cf_dna<. & df_dna<.
replace df_dna=1 if DF26_t`k'd`k2'==3 & DF27_t`k'd`k2'>=3 & DF27_t`k'd`k2'<97 & df_vp!=1 & a1==1 & cf_dna>0 & cf_dna<. & df_dna<.
replace df_dna=1 if DF26_t`k'd`k2'==2 & DF27_t`k'd`k2'>=1 & DF27_t`k'd`k2'<97 & df_vp!=1 & a1==1 & cf_dna>0 & cf_dna<. & df_dna<.
replace df_dna=1 if DF26_t`k'd`k2'==1 & DF28_t`k'd`k2'==1 & df_vp!=1 & a1==1 & cf_dna>0 & cf_dna<. & df_dna<.
}
replace df_dna=1 if F40_t8d`k2'==4 & df_vp!=1 & a1==1 & cf_dna>0 & cf_dna<. & df_dna<.
}
}
replace df_dna=((g9_1==1 | g9_2==1 | g9_3==1 | g9_4==1 | g9_5==1 | g9_6==1) & a1==1 & df_vp!=1) if (df_dna==0 | df_dna==.) & df_vp!=1 & a1==1 & d_dna>0 & d_dna<. & cf_dna>0 & cf_dna<.
//replace df_dna=((g7_1==1 | g7_2==1 | g7_3==1 | g7_4==1 | g7_5==1) & ord==1 & df_vp!=1) if (df_dna==0 | df_dna==.) & df_vp!=1 & a1==1 & d_dna>0 & d_dna<. & cf_dna>0 & cf_dna<.
replace df_dna=. if cf_dna==0 | cf_dna==.
replace df_dna=. if d_dna==0 | d_dna==.
replace df_dna=. if a1!=1
replace df_vp=. if a1!=1
tab df_dna
tab df_dna df_vp
tab df_vp df_vp_original
tab df_dna df_dna_original
rename df_vp df_vp_new
rename df_dna df_dna_new
rename df_vp_original df_vp 
rename df_dna_original df_dna 
//   //    //    //   //   //   //   //   //    //    //    //   //     //



*g cf_dt = cf_dt_old
*g cf_dna = cf_dna_old
*g ing=ln(yefec+1000)
replace ytoth = ytot_ind if ytoth==. & a1==1
replace ytoth = ytot_ind if ytoth==. & a2==1
g yefec = ytoth-yai
replace yefec=ytoth if yefec==.
sum yefec if yefec>0
g ing=ln(yefec+1000)
*g ing=ln(yefec+r(min)) 

* Creacin variables de caracterizacin


* Situacin laboral
*g ocup = 0
*replace ocup = 1 if (c1==1 | c2==1 | c3==1) // Condicin de ocupados definido en el cuestionario
drop ocuph
egen ocuph = total(ocup), by(folio)

* Desempleados por hogar (personas que pertenecen a la FL)
g desem=0 // same as unempl
replace desem=1 if c2==2 | c3==2 | c4==1
by folio, sort: egen desem_h=sum(desem)  // same as unempl_h
* Individuos del hogar en la FL
g flab_0=0  // same a lfp
replace flab_0=1 if ocup==1 | desem==1
replace ocup = . if flab_0==0
replace desem = . if flab_0==0
bysort folio: egen flab=sum(flab_0)
* Individuos del hogar en edad de trabajar
g pet_0=0
replace pet_0=1 if (edad>15 & edad<65) & d2_2!=1 & d3_3!=1
replace pet_0=1 if ocup==1 | desem==1
bysort folio: egen pet=sum(pet_0)
* estado civil
g casado=0 if a1==1
replace casado=1 if a7==1 & a1==1
* indicacion ocupacion
g tipo_trab=0 if (c10==1 | c10==2 | c10==9) & a1==1
replace tipo_trab=1 if (c10>2 & c10<9) & a1==1

* Actividad economica 
g isicrev2=c9_cod if a1==1
replace isicrev2=2302 if isicrev2==2329
replace isicrev2=3111 if isicrev2==3110
replace isicrev2=3411 if isicrev2==3410
sort isicrev2
joinby isicrev2 using "$path2b\isic1.dta", unmatched(master)
drop _merge
* Rama actividad econmica
g actividad=0
forv k=0/9 {
local p=(1000*`k')
replace actividad=`k' if isicrev2>=`p' & isicrev2<`p'+999
}
replace actividad=. if actividad==0
replace actividad=. if actividad==10
replace actividad = 1 if actividad==2
replace actividad = 3 if actividad==4
* Sector economico - Primario, Secundario, Terciario
g sector_ind = actividad
recode sector_ind 0/2=1 3/5=2 6/9=3


* Imputacin edad
bysort class_com2003 sexo: egen med_edad=median(edad)
replace edad=round(med_edad) if edad==.

*global factor_op expr0531
*do "$path_bs_do\ingresos_efh" // Creates income variables
g tr_edad=0
replace tr_edad=1 if edad>=15 & edad<25
replace tr_edad=2 if edad>=25 & edad<35
replace tr_edad=3 if edad>=35 & edad<45
replace tr_edad=4 if edad>=45 & edad<55
replace tr_edad=5 if edad>=55 & edad<65
replace tr_edad=5 if edad>=65 
* Tramos de edad 2 - Young, Middle Age, Old
g tr_edad2 = tr_edad
recode tr_edad2 1/2=1 3/4=2 5=3
g edad2 = edad^2

// Nr of children, adults and seniors in household
g aux_edad = (edad<=19)
g aux_edad1=(edad>19 & edad<=64)
g aux_edad2 = (edad>64)

bysort folio: egen num_men=sum(aux_edad)
recode num_men (3/.=3) // use 3 or 4 as upper bound
bysort folio: egen num_adult=sum(aux_edad1)
recode num_adult (4/.=4) // use 4 or 5 as upper bound
bysort folio: egen num_sen=sum(aux_edad2)
recode num_sen (1/.=1) // use 1 or 2 as upper bound

bysort class_com2003 sexo tedad: egen m_s=median(s)
replace s=round(m_s) if s==. 

* clasifiacin nivel de educacin

bysort class_com2003 sexo tedad: egen niv_m=median(nive_edu) if nive_edu<97
g nive_edu2=nive_edu
replace nive_edu=niv_m if nive_edu==. | nive_edu>97 & (ocup==1 | desem==1)

g nivel=.
replace nivel = 1 if nive_edu>0 & nive_edu<=8 
replace nivel = 2 if nive_edu>8 & nive_edu<=12 
replace nivel = 3 if nive_edu>12 & nive_edu<=15 
replace nivel = 1 if nivel==. & tedu==1
replace nivel = 2 if nivel==. & tedu==2
replace nivel = 3 if nivel==. & tedu==3
replace nivel = 3 if nivel==. & tedu==4

* Regionalizacin
g lugar=.
replace lugar = 1 if region>0 & region<=12
replace lugar = 2 if region==13

* Incorporando probabilidades de ESI
*drop _merge

* RCI modificado con regla de max
g rci_min1=min(rci_dt,1)
g us_rci_75=(rci_min1>0.75)
g rci_pend_75=rci_min1*(1-us_rci_75)
bysort folio: egen casado2 = mean(casado)
gen genero = (sexo==1)
gen hombre_casado=casado2*genero

g trab=ocuph/flab
g nivel2 = nivel
g baja=(nivel2<2)
g bas_med=(nivel2==1)
g instituto=(nivel2==2)
g universidad=(nivel2==3)

joinby folio using "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\2011\Data\Base_trabajo\factores_folio.dta", unmatched(both)
tab _merge
drop if _merge!=3
drop _merge

rename nivel educ
sum zona2
local z_min =r(min)
local z_max =r(max)
g decil_h = .
forv k=`z_min'/`z_max' {
xtile decil_h0 =  ytoth if zona2==`k' [fw=${factor_op}], nq(10)
replace decil_h = decil_h0 if decil_h==.
drop decil_h0
}
g decil_h0 = decil_h if a1==1
bysort folio: egen decil_h1 = mean(decil_h)
replace decil_h = ceil(decil_h1) if decil_h==.
drop decil_h0 decil_h1
g estrato_h = decil_h
recode estrato_h 1/5=1 6/8=2 9=3 10=4
g quintile_h = ceil(decil_h/2)

// Probability of unemployment
g year = 2011 //2009
g quarter = 4
g constant = 1
if ${esi_bt_op}==1 { // Use ESI bootstrap option
layoff_jobfind 12
}
if ${esi_bt_op}==0 {
layoff_jobfind0 12
}
drop quarter
//

rename unemployed pr_unemployed
g factor_un = ceil(${factor_op}*(1/pr_unemployed) )
replace factor_un = 1 if factor_un<1
replace factor_un = ${factor_op} if factor_un==.
g factor_e = ceil(${factor_op}*(1/(1-pr_unemployed)) )
replace factor_e = 1 if factor_e<1
replace factor_e = ${factor_op} if factor_e==.

g dec_renta0 = .
g dec_renta1 = .
forv k=`z_min'/`z_max' {
xtile dec_renta0_0 = ytot_ind if desem==0 & ytot_ind>0 & zona2==`k' [fw=factor_e], nq(10)
xtile dec_renta1_0 = ytot_ind if desem==1 & ytot_ind>0 & zona2==`k' [fw=factor_un], nq(10)
replace dec_renta0 = dec_renta0_0 if dec_renta0==.
replace dec_renta1 = dec_renta1_0 if dec_renta1==.
drop dec_renta0_0 dec_renta1_0
}
replace dec_renta0 = decil_h if dec_renta0==. & desem==0
replace dec_renta1 = decil_h if dec_renta1==. & desem==1
replace dec_renta0 = 1 if dec_renta0==. & desem==0
replace dec_renta1 = 1 if dec_renta1==. & desem==1
g dec_renta=dec_renta0 if desem==0
replace dec_renta=dec_renta1 if desem==1 
replace dec_renta=0 if ytot_ind==0 & desem<.
drop dec_renta0 dec_renta1
g quintile_renta = ceil(dec_renta/2)

replace tr_edad = . if tr_edad==0
replace tr_edad2 = . if tr_edad2==0
egen numh = count(folio), by(folio)

g unemployed = desem 
capture drop _merge
if ${esi_bt_op}==1 { // Use ESI bootstrap option
income_shock 12
}
if ${esi_bt_op}==0 {
income_shock0 12
}
run "$path_bs_do\p_income" // Calculates Permanent Income of the Family
drop unemployed 
capture drop _merge
*joinby folio using "D:\DAT\DPF\Analisis Financiero\Sector Hogares\EFH\2011\Data\Base_trabajo\Factores_Data\factores_efh11_casen_vs2.dta", ///
*unmatched(master)

replace df_dna=. if cf_dna==0 | cf_dna==.
*replace df_dna=. if d_dna==0 | d_dna==.
replace df_dna=. if a1!=1
*replace df_vp=. if a1!=1

// Tenency of bank debt and bank debt
*Tenencia de deuda bancaria
capture drop banco // already created, but it is the same variable and results are the same
g banco = 0
replace banco = 1 if (ctbco==1 | cbco==1)
g debtor = (d_dna>0) if d_dna<.
replace banco = min(banco, debtor)
* Banking consumer debt
egen deuda_cons_banco = rowtotal(dcbco dtbco)
reg deuda_cons_banco i.(c_vp sexo zona2 sector_ind tr_edad2 educ quintile_h) if banco==1
predict dtcbco_0
replace deuda_cons_banco = dtcbco_0 if banco==1 & deuda_cons_banco==.
replace deuda_cons_banco = dtcbco_0 if banco==1 & deuda_cons_banco==0
replace deuda_cons_banco = 0 if deuda_cons_banco==.
replace deuda_cons_banco = 0 if a1!=1
replace deuda_cons_banco = max(0,deuda_cons_banco)

// Debt Prioritization (only EFH 2010, 2011)
g G4=g10
g G5_1=.
g G5_2=.    
forv k=1/14{
replace G5_1=`k' if g11_`k'==1 & G5_1==.
replace G5_2=`k' if g11_`k'==1 & G5_2==. & G5_1!=. & G5_1!=`k'
}
g G6_1=.
g G6_2=.
g G6_3=.
forv k=1/7{
replace G6_1=`k' if g12_`k'==1 & G6_1==.
replace G6_2=`k' if g12_`k'==1 & G6_2==. & G6_1!=. & G6_1!=`k'
replace G6_3=`k' if g12_`k'==1 & G6_3==. & G6_1!=. & G6_2!=. & G6_1!=`k' & G6_2!=`k'
}
//    //   //    //    //   //
// d_td1 d_td2 d_td3 d_td4 d_td5 d_td6 d_td7 d_td8 d_dotras d_dna d_dt d_dtot d_cons // EFH 2014
// cf_dna cf_dt cf_dtot cf_td1 cf_td2 cf_td3 cf_td4 cf_td5 cf_td6 cf_td7 cf_td8 cf_dotras // EFH 2014
// cfdtbco cfdtcc cfdcbco cffin cfdauto cfdsocial cfdeduc dtbco dtcc dcbco dfin dauto dsocial deduc cf_dna d_dna // EFH 2007 al 2011
g cf_td1 = cf_1
g cf_td3 = cf_3
g cf_td4 = cf_5
g cf_td5 = cf_4
g cf_td6 = cf_7
g cf_td7 = cf_6
g cf_td8 = cf_8
replace cf_td7 = max(cfdauto,cf_td7)
replace cf_td6 = max(cfdsocial,cf_td6) 
replace cf_td8 = max(cfdeduc,cf_td8) 
//
g d_td1 = d_1
g d_td3 = d_3
g d_td4 = d_5
g d_td5 = d_4
g d_td6 = d_7
g d_td7 = d_6
g d_td8 = d_8
replace d_td7 = max(dauto,d_td7)
replace d_td6 = max(dsocial,d_td6) 
replace d_td8 = max(deduc,d_td8) 
//
rename meses_inicio_t4 meses_inicio_t50
rename meses_inicio_t5 meses_inicio_t4
rename meses_inicio_t6 meses_inicio_t70
rename meses_inicio_t7 meses_inicio_t6
rename meses_inicio_t50 meses_inicio_t5
rename meses_inicio_t70 meses_inicio_t7
//
rename meses_apagar_t4 meses_apagar_t50
rename meses_apagar_t5 meses_apagar_t4
rename meses_apagar_t6 meses_apagar_t70
rename meses_apagar_t7 meses_apagar_t6
rename meses_apagar_t50 meses_apagar_t5
rename meses_apagar_t70 meses_apagar_t7

rename mese meses_survey
g year_survey = 2011 if meses_survey>=7
replace year_survey = 2012 if meses_survey<=5
g date_survey = ym(year_survey, meses_survey)
format %tm date_survey

replace year = 2011
capture gen gtotal = .
//   //			//		//			//		//		//
g desem_2 = 0 if c1==1 | c2==1 | c3==1 & edad>=15 & edad<.
replace desem_2= 1 if (c2==2 | c3==2) & c4==1 & edad>=15 & edad<.
replace desem_2= 1 if c4==1 & edad>=15 & edad<.
*replace desem_2= 1 if (c2==2 | c3==2) & c5==1 & edad>=15 & edad<.
sum desem desem_2 [fw=factor_cvars1112] 
tab desem desem_2 [fw=factor_cvars1112] 
replace desem = desem_2
drop desem_2
g act_tot = a_var + a_fijo + vp + otp + a_auto  
gen deuda_tot   = dhip_vp +dhip_otp +dtbco+ dtcc +dcbco+ dfin+ dauto +dsocial +deduc +dotros
gen rda=deuda_tot/max(1,act_tot)
capture rename dhip d_vp
//   //			//		//			//		//		//
keep folio a1 a2 flab_0 pet_0 sh_inc* sexo lfp* sector_ind actividad tedad factor_cvars1112 zona2 s ocup desem pet_0 pet casado tipo_trab ///
tr_edad* tedad s nive_edu* lugar ytot* tedu c_vp vivprop num_adul num_men num_sen rci* df_dna df_vp ing rci_pend_75 us_rci_75 numh edad* hombre_casado genero ///
instituto universidad cf* dec_renta educ constant year decil_h estrato_h layoffs_sect jobfind zona* class_c* d_dna quintile* gtotal ///
a_var a_fijo a_auto unemp_sect  yai yaotp yact deuda_cons_banco banco *_sect ytot_p_h p_cons p_tbco p_ccom p_cbco p_fin cfdtbco d_dt d_vp ///
cfdtbco cfdtcc cfdcbco cffin cfdauto cfdsocial cfdeduc dtbco dtcc dcbco dfin dauto dsocial deduc cf_dna d_dna ///
d_td1 d_td3 d_td4 d_td5 d_td6 d_td7 d_td8 cf_td1 cf_td3 cf_td4 cf_td5 cf_td6 cf_td7 cf_td8 rda ///
EDF* DF* F40* df_*_new G4* G5* G6* meses_inicio_t* meses_apagar_t* tarjetas_bancaria_al_dia tarjetas_cc_al_dia date_survey
drop cf_*_*   // yo* yp* year_* year_*_*

save "$path4b\\${data_save}_11.dta", replace

keep if a1==1
keep folio meses_apagar_t* date_survey
foreach var of varlist folio meses_apagar_t* date_survey {
rename `var' `var'_2011
}
save "$path4b\\${data_save}_11_vs2.dta", replace
}
//
